# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%define jar_name mail

%define jmailver  1.4.1
%define oname  glassfish-javamail

Name:           glassfish-javamail141
Version:        1.4.1
Release:        7%{?dist}
Epoch:          0
Summary:        Glassfish - JavaMail API
License:        CDDL
Group:          Development/Java
URL:            http://glassfish.dev.java.net/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
Source0:        %{oname}-%{version}.tar.gz
#svn export https://svn.java.net/svn/glassfish~svn/trunk/api/mail
#tar czf ../SOURCES/glassfish-javamail-1.4.1.tar.gz mail/
Source1:        glassfish-legal.tar.gz
#svn export https://svn.java.net/svn/glassfish~svn/trunk/legal
#tar czf ../SOURCES/glassfish-legal.tar.gz legal/
Source4:        %{name}-settings.xml
Source5:        %{name}-jpp-depmap.xml
Source8:        %{oname}-component-info.xml

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  glassfish-jaf111
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  apache-commons-parent

Requires:       jaf_1_1_1_api
Provides:       javamail = 0:%{jmailver}
Provides:       javamail-monolithic = 0:%{jmailver}
Provides:       glassfish-javamail = %{epoch}:%{version}-%{release}
Provides:       javamail_api = 0:%{jmailver}
Provides:       javamail_1_4_1_api = 0:%{jmailver}

%description
JavaMail Api from Glassfish

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:       javamail-javadoc = 0:%{jmailver}

%description javadoc
%{summary}.

%prep
%setup -q -c
%setup -q -c -T -D -a 1

cp -p %{SOURCE4} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

%build
export CLASSPATH=
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}
export MAVEN_SETTINGS=$(pwd)/settings.xml

cd mail
%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven2.jpp.depmap.file=%{SOURCE5} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 0644 mail/target/%{jar_name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-monolithic-%{version}.jar

%add_to_maven_depmap javax.mail mail %{version} JPP %{name}-monolithic

pushd $RPM_BUILD_ROOT%{_javadir}
ln -sf %{name}-monolithic-%{version}.jar %{name}.jar
ln -sf %{name}-monolithic-%{version}.jar %{name}-monolithic.jar
popd

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)
touch $RPM_BUILD_ROOT%{_javadir}/javamail.jar
touch $RPM_BUILD_ROOT%{_javadir}/javamail_api.jar
touch $RPM_BUILD_ROOT%{_javadir}/javamail_1_4_1_api.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 mail/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom
install -m 644 mail/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-monolithic.pom

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr mail/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/javamail.jar javamail %{_javadir}/%{name}-monolithic-%{version}.jar 10401
%{_sbindir}/update-alternatives --install %{_javadir}/javamail_api.jar javamail_api %{_javadir}/%{name}-monolithic-%{version}.jar 10401
%{_sbindir}/update-alternatives --install %{_javadir}/javamail_1_4_1_api.jar javamail_1_4_1_api %{_javadir}/%{name}-monolithic-%{version}.jar 10401

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove javamail %{_javadir}/%{name}-monolithic-%{version}.jar
    %{_sbindir}/update-alternatives --remove javamail_api %{_javadir}/%{name}-monolithic-%{version}.jar
    %{_sbindir}/update-alternatives --remove javamail_1_4_1_api %{_javadir}/%{name}-monolithic-%{version}.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc legal/src/main/resources/META-INF/LICENSE.txt
%{_javadir}/%{name}-monolithic-%{version}.jar
%{_javadir}/%{name}-monolithic.jar
%{_javadir}/%{name}.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%{_javadir}/%{name}
%ghost %{_javadir}/javamail.jar
%ghost %{_javadir}/javamail_api.jar
%ghost %{_javadir}/javamail_1_4_1_api.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Fri Jan 20 2012 Ralph Apel <r.apel@r-apel.de> 0:1.4.1-7
- Bump Release 
- Promote to free
- Provide javamail_api = 0:1.4.1
- Provide javamail_1_4_1_api

* Wed Jun 08 2011 Ralph Apel <r.apel@r-apel.de> 0:1.4.1-1
- 1.4.1 as glassfish-javamail141

